<script lang="ts" setup>
import type { VxeGridListeners } from '#/adapter/vxe-table';

import { ref } from 'vue';

import { Page, useVbenModal } from '@vben/common-ui';

import { Button, Image, message, Tag } from 'ant-design-vue';

import { useVbenVxeGrid } from '#/adapter/vxe-table';
import { TableAction } from '#/components/table-action';
import { downloadByData } from '#/util/tool';

import { deleteChinaMedicine, exportChinaMedicineApi } from './api';
import DrugNumberBatchModal from './components/DrugNumberBatchModal.vue';
import FormModalDemo from './components/modal.vue';
import ExcelUpload from './components/ExcelUpload.vue';
import { formOptions } from './config/search';
import { gridOptions } from './config/table';

const hasTopTableDropDownActions = ref(false);

const gridEvents: VxeGridListeners<any> = {
  checkboxChange() {
    // eslint-disable-next-line no-use-before-define
    const records = gridApi.grid.getCheckboxRecords();
    hasTopTableDropDownActions.value = records.length > 0;
  },
  checkboxAll() {
    // eslint-disable-next-line no-use-before-define
    const records = gridApi.grid.getCheckboxRecords();
    hasTopTableDropDownActions.value = records.length > 0;
  },
};

const [Grid, gridApi] = useVbenVxeGrid({
  formOptions,
  gridOptions,
  gridEvents,
});

const [FormModal, formModalApi] = useVbenModal({
  connectedComponent: FormModalDemo,
});

const [ExcelUploadModal, ExcelUploadModalApi] = useVbenModal({
  connectedComponent: ExcelUpload,
});

const [DrugNumberBatchModalComp, drugNumberBatchModalApi] = useVbenModal({
  connectedComponent: DrugNumberBatchModal,
});

const showModal = (data = {}, isUpdate = false) => {
  formModalApi.setData({
    // 表单值
    values: data,
    update: isUpdate,
    gridApi,
  });
  formModalApi.open();
};

const deleteApi = (row: any) => {
  let ids = [];
  if (row) {
    ids.push(row);
  } else {
    ids = gridApi.grid.getCheckboxRecords().map((item) => item.id);
  }
  deleteChinaMedicine({ ids }).then(() => {
    message.success('删除成功!');
    gridApi.query();
  });
};
/**
 * 中药导出
 */
const passApplication = () => {
  // 新标签跳转到 exportChinaMedicineApi
  exportChinaMedicineApi().then((res) => {
    // 创建新的URL表示指定的File对象或者Blob对象。
    downloadByData(res.data, '萧康云医-中药导出.xlsx');
    message.success('导出成功!');
  });
};

const openExcelUploadModal = () => {
  ExcelUploadModalApi.setData({
    gridApi,
  });
  ExcelUploadModalApi.open();
};

const openDrugNumberBatchModal = () => {
  drugNumberBatchModalApi.setData({
    gridApi,
  });
  drugNumberBatchModalApi.open();
};
</script>

<template>
  <Page auto-content-height title="中药管理">
    <ExcelUploadModal />
    <DrugNumberBatchModalComp />
    <FormModal />
    <Grid>
      <template #toolbar-buttons>
        <TableAction
          :actions="[
            {
              label: '新增',
              type: 'primary',
              icon: 'ant-design:plus-outlined',
              // auth: ['超级中药', 'sys:user:save'],
              onClick: showModal.bind(null),
            },
            {
              label: '导入',
              type: 'primary',
              icon: 'ix:export-check',
              // auth: ['超级中药', 'sys:user:save'],
              onClick: openExcelUploadModal.bind(null),
            },
            {
              label: '批量更新编码',
              type: 'default',
              icon: 'ant-design:barcode-outlined',
              onClick: openDrugNumberBatchModal.bind(null),
            },
            {
              label: '导出',
              type: 'primary',
              icon: 'mingcute:download-3-fill',
              // auth: ['超级中药', 'sys:user:save'],
              onClick: passApplication.bind(null),
            },
          ]"
          :drop-down-actions="[
            {
              label: '删除',
              icon: 'ant-design:delete-outlined',
              ifShow: hasTopTableDropDownActions,
              // auth: ['超级中药', 'sys:user:save'],
              popConfirm: {
                title: '确定删除吗？',
                confirm: deleteApi.bind(null, false),
              },
            },
          ]"
        >
          <template #more>
            <Button style="margin-left: 16px">
              批量操作
              <Icon icon="ant-design:down-outlined" />
            </Button>
          </template>
        </TableAction>
      </template>
      <template #status="{ row }">
        <Tag :color="row.status_color">{{ row.status_txt }}</Tag>
      </template>
      <template #toolbar-tools></template>
      <template #action="{ row }">
        <TableAction
          :actions="[
            {
              label: '编辑',
              type: 'link',
              icon: 'uil:edit',
              size: 'small',
              // auth: ['china-medicine', 'sys:role:detail'],
              onClick: showModal.bind(null, row, true),
            },
            {
              label: '删除',
              type: 'link',
              icon: 'ant-design:delete-outlined',
              size: 'small',
              // auth: ['china-medicine', 'sys:role:detail'],
              popConfirm: {
                title: '确定删除吗？',
                confirm: deleteApi.bind(null, row.id),
              },
            },
          ]"
          :drop-down-actions="[]"
        />
      </template>
    </Grid>
  </Page>
</template>
